




<!DOCTYPE html>
<html>
<head>
<title>Taro -- 使用 Redux 来进行全局变量的管理 -  码上快乐</title>
<meta name="keywords" content="Taro" />
<meta name="description" content="前言 Redux是JavaScript 状态容器，提供可预测化的状态管理。一般来说，规模比较大的小程序，页面状态，数据缓存，需要管理的东西太多，这时候引入Redux可以方便的管理这些状态，同一数据，一次请求，应用全局共享。 而Taro也非常友好地为开发者提供了移植的Redux。 为了更方便地使用Re" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="Taro -- 使用 Redux 来进行全局变量的管理" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/a976a81/Taro-使用-Redux-来进行全局变量的管理"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/a976a81.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/a976a81.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/a976a81.html" style="color:black">Taro -- 使用 Redux 来进行全局变量的管理</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vanVld3V6aGUvcC8xMTEwNTk2MC5odG1s" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2019-06-29 14:29</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>3680&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     
                     <span><a href='/tag/Taro' target="_blank">Taro</a></span>                     
                     
                  
                  <i class="icon-star" title="9.1001"></i>
                  <i class="icon-star" title="9.1001"></i>
                  <i class="icon-star" title="9.1001"></i>
                  <i class="icon-star" title="9.1001"></i>
                  <i class="icon-star" title="9.1001"></i>                  
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <p><strong>前言</strong></p> 
<p>Redux是JavaScript 状态容器，提供可预测化的状态管理。一般来说，规模比较大的小程序，页面状态，数据缓存，需要管理的东西太多，这时候引入Redux可以方便的管理这些状态，同一数据，一次请求，应用全局共享。</p> 
<p>而Taro也非常友好地为开发者提供了移植的Redux。</p> 
<p>为了更方便地使用<code>Redux</code>，Taro提供了与<code>react-redux</code>&nbsp;API 几乎一致的包&nbsp;<code>@tarojs/redux</code>&nbsp;来让开发人员获得更加良好的开发体验。</p> 
<p><strong>使用 Redux 来进行全局变量的管理</strong></p> 
<p>1、在pages 同级目录新建4个文件夹。<br>store、actions、reducers、constants</p> 
<p>store: 创建全局单一的store。</p> 
<p>actions：用于描述发生什么事件。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>reducers：用于action如何改变state树。</p> 
<p>constants：用于定义所需的<code>action type</code>常量。</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;">store/index.js文件</span>
<span style="color: #000000;">
import { createStore, applyMiddleware, compose } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">redux</span><span style="color: #800000;">'</span><span style="color: #000000;">
import thunkMiddleware </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">redux-thunk</span><span style="color: #800000;">'</span><span style="color: #000000;">
import rootReducer </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">../reducers</span><span style="color: #800000;">'</span>

<span style="color: #0000ff;">const</span> composeEnhancers =
  <span style="color: #0000ff;">typeof</span> window === <span style="color: #800000;">'</span><span style="color: #800000;">object</span><span style="color: #800000;">'</span> &amp;&amp;<span style="color: #000000;">
  window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ </span>?<span style="color: #000000;">   
    window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__({
      </span><span style="color: #008000;">//</span><span style="color: #008000;"> Specify extension’s options like name, actionsBlacklist, actionsCreators, serialize...</span>
<span style="color: #000000;">    }) : compose

</span><span style="color: #0000ff;">const</span> middlewares =<span style="color: #000000;"> [
  thunkMiddleware
]

</span><span style="color: #0000ff;">if</span> (process.env.NODE_ENV === <span style="color: #800000;">'</span><span style="color: #800000;">development</span><span style="color: #800000;">'</span><span style="color: #000000;">) {
  middlewares.push(require(</span><span style="color: #800000;">'</span><span style="color: #800000;">redux-logger</span><span style="color: #800000;">'</span><span style="color: #000000;">).createLogger())
}

</span><span style="color: #0000ff;">const</span> enhancer =<span style="color: #000000;"> composeEnhancers(
  applyMiddleware(...middlewares),
  </span><span style="color: #008000;">//</span><span style="color: #008000;"> other store enhancers if any</span>
<span style="color: #000000;">)

export </span><span style="color: #0000ff;">default</span><span style="color: #000000;"> function configStore () {
  </span><span style="color: #0000ff;">const</span> store =<span style="color: #000000;"> createStore(rootReducer, enhancer)
  </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> store
}</span></pre> 
</div> 
<p>首先在<code>app.js</code>中引入一开始定义好的<code>store</code>，使用<code>@tarojs/redux</code>中提供的<code>Provider</code>组件将前面写好的<code>store</code>接入应用中，这样一来，被<code>Provider</code>包裹的页面都能共享到应用的<code>store</code>。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<div class="cnblogs_code"> 
 <pre>//app.js<br>import Taro, { Component } <span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">@tarojs/taro</span><span style="color: #800000;">'</span><span style="color: #000000;">
import { Provider } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">@tarojs/redux</span><span style="color: #800000;">'</span><span style="color: #000000;">
 
import configStore </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">./store</span><span style="color: #800000;">'</span><span style="color: #000000;">
import Index </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">./pages/index</span><span style="color: #800000;">'</span><span style="color: #000000;">
 
import </span><span style="color: #800000;">'</span><span style="color: #800000;">./app.scss</span><span style="color: #800000;">'</span>
 
<span style="color: #0000ff;">const</span> store =<span style="color: #000000;"> configStore()
 
</span><span style="color: #0000ff;">class</span><span style="color: #000000;"> App extends Component {
 ...
 render () {
  </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> (
   </span>&lt;<span style="color: #3366ff;">Provider</span> store={store}&gt;
    &lt;Index /&gt;
   &lt;/<span style="color: #3366ff;">Provider</span>&gt;<span style="color: #000000;"> 
  )
 }
}<br></span></pre> 
</div> 
<p><code>constants</code>文件夹来定义一系列所需的<code>action type</code>常量</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;">constants/login.js</span>
<span style="color: #000000;"> 
export </span><span style="color: #0000ff;">const</span> LOGIN_TYPE = <span style="color: #800000;">"</span><span style="color: #800000;">login_type</span><span style="color: #800000;">"</span></pre> 
</div> 
<p>然后开始创建处理指令的<code>reducers</code>。</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;"> reducers/index.js</span>
<span style="color: #000000;"> 
import { combineReducers } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">redux</span><span style="color: #800000;">'</span><span style="color: #000000;">
import login </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">"</span><span style="color: #800000;">./login</span><span style="color: #800000;">"</span><span style="color: #000000;">

export </span><span style="color: #0000ff;">default</span><span style="color: #000000;"> combineReducers({
  <span style="color: #ff0000;">login</span>
})</span></pre> 
</div> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;"> reducers/login.js</span>
<span style="color: #000000;">
import {LOGIN_TYPE} </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">"</span><span style="color: #800000;">../constants/login</span><span style="color: #800000;">"</span>
<span style="color: #0000ff;">const</span> INITIAL_STATE =<span style="color: #000000;"> {
  loginType: </span><span style="color: #0000ff;">false</span><span style="color: #000000;">
}

export </span><span style="color: #0000ff;">default</span> function login (state =<span style="color: #000000;"> INITIAL_STATE, action) {
  </span><span style="color: #0000ff;">switch</span><span style="color: #000000;"> (action.type) {
    </span><span style="color: #0000ff;">case</span><span style="color: #000000;"> LOGIN_TYPE:
      </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> {
        ...state,
        loginType: action.data
      }
    </span><span style="color: #0000ff;">default</span><span style="color: #000000;">:
      </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> state
  }
}</span></pre> 
</div>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>接着在<code>actions</code>中定义函数对应的指令。</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;">actions/login.js</span>
<span style="color: #000000;">
import {LOGIN_TYPE} </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">"</span><span style="color: #800000;">../constants/login</span><span style="color: #800000;">"</span><span style="color: #000000;">
 
export </span><span style="color: #0000ff;">const</span> <span style="color: #ff00ff;">loginTypeFun</span> = (data) =&gt;<span style="color: #000000;"> {
 </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> {
  type: LOGIN_TYPE,
  data: data
 }
}</span></pre> 
</div> 
<p>&nbsp;最后实现数据状态的改变</p> 
<div class="cnblogs_code"> 
 <pre><span style="color: #008000;">//</span><span style="color: #008000;">pages/index/index.js</span>
<span style="color: #000000;">
import Taro, { Component } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">@tarojs/taro</span><span style="color: #800000;">'</span><span style="color: #000000;">
import { View } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">'</span><span style="color: #800000;">@tarojs/components</span><span style="color: #800000;">'</span><span style="color: #000000;">
import { AtButton } </span><span style="color: #0000ff;">from</span> <span style="color: #800000;">"</span><span style="color: #800000;">taro-ui</span><span style="color: #800000;">"</span><span style="color: #000000;">
import </span><span style="color: #800000;">'</span><span style="color: #800000;">./index.scss</span><span style="color: #800000;">'<br></span></pre> 
 <pre><span>import { connect } from '@tarojs/redux'</span></pre> 
 <pre><span style="color: #800000;">import { </span><span style="color: #ff00ff;">loginTypeFun</span> <span style="color: #800000;">} from '../../actions/login'</span></pre> 
 <pre><em id="__mceDel"><span style="color: #000000;"> @connect(({ <span style="color: #ff0000;">login</span> }) </span>=&gt;<span style="color: #000000;"> ({ <span style="color: #ff0000;">login</span> }), (dispatch) </span>=&gt;<span style="color: #000000;"> ({ changeLoginType(data) { dispatch(<span style="color: #ff00ff;">loginTypeFun</span>(data)}) } })) </span><span style="color: #0000ff;">class</span><span style="color: #000000;"> Index extends Component { constructor () { super(...arguments) </span><span style="color: #0000ff;">this</span>.state =<span style="color: #000000;"> ({ }) } config </span>=<span style="color: #000000;"> { navigationBarTitleText: </span><span style="color: #800000;">'</span><span style="color: #800000;">首页</span><span style="color: #800000;">'</span><span style="color: #000000;"> } componentWillMount() { } toChangeLogin </span>= (e) =&gt;<span style="color: #000000;"> { </span><span style="color: #0000ff;">this</span>.props.changeLoginType(<span style="color: #0000ff;">true</span><span style="color: #000000;">) } } render () { </span><span style="color: #0000ff;">return</span><span style="color: #000000;"> ( </span>&lt;View className=<span style="color: #800000;">'</span><span style="color: #800000;">index</span><span style="color: #800000;">'</span>&gt;<span style="color: #000000;"> {</span><span style="color: #008000;">this</span><span style="color: #000000;"><span style="color: #008000;">.props.login.loginType</span>} </span>&lt;AtButton <span style="color: #800000;">type="primary" onClick={this.toChangeLogin}&gt;改变状态loginType&lt;/AtButton&gt;</span>
      &lt;/View&gt;<span style="color: #000000;"> ) } } export </span><span style="color: #0000ff;">default</span> Index</em></pre> 
</div>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>&nbsp;输出结果true</p> 
<p><img src="/image/aHR0cHM6Ly9pbWcyMDE4LmNuYmxvZ3MuY29tL2Jsb2cvMTE2ODMyMS8yMDE5MDYvMTE2ODMyMS0yMDE5MDYyOTE0MjgxMjQ1Ni00NDk0NDA4ODIucG5n.png" alt="" referrerpolicy="no-referrer"></p> 
<p>&nbsp;</p>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8944941.html" title="php全局变量的使用">
			           <i class="icon-fire"></i>
			           
			           php全局变量的使用
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a9aa5a1.html" title="谨慎使用全局变量">
			           
			           <i class="icon-file"></i>
			           谨慎使用全局变量
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b2d5a71.html" title="Vue中使用全局变量">
			           
			           <i class="icon-file"></i>
			           Vue中使用全局变量
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/4a396e1.html" title="matlab 全局变量的使用举例">
			           <i class="icon-fire"></i>
			           
			           matlab 全局变量的使用举例
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a80b0c1.html" title="vue添加使用全局变量">
			           <i class="icon-fire"></i>
			           
			           vue添加使用全局变量
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b0bbf11.html" title="PHP中$_SERVER全局变量的使用">
			           
			           <i class="icon-file"></i>
			           PHP中$_SERVER全局变量的使用
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a3244b1.html" title="spring mvc 使用全局变量">
			           
			           <i class="icon-file"></i>
			           spring mvc 使用全局变量
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a5e5fe1.html" title="Python跨文件全局变量的使用">
			           <i class="icon-fire"></i>
			           
			           Python跨文件全局变量的使用
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9c5a881.html" title="Android使用全局变量来传递数据">
			           
			           <i class="icon-file"></i>
			           Android使用全局变量来传递数据
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/4082a61.html" title="Android 使用全局变量传递数据">
			           
			           <i class="icon-file"></i>
			           Android 使用全局变量传递数据
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240329"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>